searchNodes=[{"ref":"StructCop.html","title":"StructCop","type":"behaviour","doc":""},{"ref":"StructCop.html#cast/2","title":"StructCop.cast/2","type":"function","doc":""},{"ref":"StructCop.html#cast!/2","title":"StructCop.cast!/2","type":"function","doc":""},{"ref":"StructCop.html#c:changeset/2","title":"StructCop.changeset/2","type":"callback","doc":""},{"ref":"StructCop.html#contract/1","title":"StructCop.contract/1","type":"macro","doc":""},{"ref":"StructCop.html#c:validate/1","title":"StructCop.validate/1","type":"callback","doc":""},{"ref":"StructCop.html#t:attrs/0","title":"StructCop.attrs/0","type":"type","doc":""},{"ref":"readme.html","title":"StructCop","type":"extras","doc":"StructCop StructCop is a library that was aimed to introduce data correctness and type corecion into Elixir structs. It also simplifies building valid structs with smart constructors."},{"ref":"readme.html#getting-started","title":"StructCop - Getting Started","type":"extras","doc":"Installation Add struct_copto your list of dependencies in mix.exs: def deps do [ {:struct_cop, &quot;~&gt; 0.1.0&quot;} ] end Contract Define a contract for given entity. We will be describing a single measure for sport activity: defmodule Measurement do use StructCop contract do field :elevation, :float field :lat, :float field :lng, :float field :tracked_at, :utc_datetime_usec end def validate(changeset) do import Ecto.Changeset changeset |&gt; validate_required([:tracked_at, :lat, :lng]) |&gt; validate_number(:lat, greater_than_or_equal_to: -90, less_than_or_equal_to: 90) |&gt; validate_number(:lng, greater_than_or_equal_to: -180, less_than_or_equal_to: 180) end end Usage From that moment we can: &gt; Measurement.new!(lat: 10, lng: 20, tracked_at: DateTime.utc_now()) %Measurement{ elevation: nil, lat: 10.0, lng: 20.0, tracked_at: ~U[2019-12-28 18:36:01.625656Z] } It also casts fields from binaries: &gt; Measurement.new!(lat: &quot;52.409538&quot;, lng: &quot;16.931992&quot;, tracked_at: &quot;2019-12-28T18:30:43.288080+00:00&quot;) %Measurement{ elevation: nil, lat: 52.409538, lng: 16.931992, tracked_at: ~U[2019-12-28 18:30:43.288080Z] } Passing invalid attributes raises an ArgumentError: &gt; Measurement.new!(lat: &quot;not_a_float&quot;, lng: 200.10) ** (ArgumentError) cast failed for %Measurement{elevation: nil, lat: nil, lng: nil, tracked_at: nil}: params: %{&quot;lat&quot; =&gt; &quot;not_a_float&quot;, &quot;lng&quot; =&gt; 200.1} errors: [lng: {&quot;must be less than or equal to %{number}&quot;, [validation: :number, kind: :less_than_or_equal_to, number: 180]}, tracked_at: {&quot;can&#39;t be blank&quot;, [validation: :required]}, lat: {&quot;is invalid&quot;, [type: :float, validation: :cast]}] (struct_cop) lib/struct_cop.ex:47: StructCop.cast!/2"},{"ref":"readme.html#credits","title":"StructCop - Credits","type":"extras","doc":"Tobiasz Małecki - discussing initial idea Maciej Kaszubowski - discussing initial idea"},{"ref":"use_cases.html","title":"Use cases","type":"extras","doc":"Use cases Sometimes, especially in non-CRUD domains the user actions cannot be directly mapped into the database entities along with their changesets. But still, from a frontend perspective they should be perceived as a whole. One typical example of such action, can be a registration process. It can be represented like this: defmodule RegisterUser do use StructCop @email_regex ~r/./ contract do field :id, :binary_id field :email, :string field :password, :string field :first_name, :string field :last_name, :string end @impl StructCop def validate(changeset) do import Ecto.Changeset changeset |&gt; validate_required([:id, :email, :password, :first_name, :last_name]) |&gt; validate_format(:email, @email_regex) |&gt; validate_length(:password, min: 8, max: 72) end def call(attrs) do attrs |&gt; new!() |&gt; do_call() end defp do_call(%__MODULE__{} = cmd) do # do stuff with coerced struct end end Having this, allow us to keep a clear boundary between implementation details and things which depend on this module. Interface is overt and informative, a reader can check out contract definition for allowed fields and validations or just get an error message provided by new!/1 function. Moreover, this aproach promotes fail fast philisophy. Fields in contracts are validated and in contrast to ordinary structs coerced into proper types. Code which uses structs constructed with StructCop, can safely assume that certain fields will have certain shape. No more checking if a binary is really a binary, manually converting &quot;4&quot; into an integer or what even worse, casting &quot;2019-12-09T20:57:40.429625+00:00&quot; into a %DateTime{}!"}]